Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 1ffa216657b5beb85210757a5d292a8b64bd5b79)
+++ src/molecules.cpp	(revision 69eb71ca95b6ddd8113c4c58130d3a649792ac26)
@@ -1,6 +1,6 @@
 /** \file molecules.cpp
- * 
+ *
  * Functions for the class molecule.
- * 
+ *
  */
 
@@ -25,5 +25,5 @@
       sum += (gsl_vector_get(x,j) - (vectors[i])->x[j])*(gsl_vector_get(x,j) - (vectors[i])->x[j]);
   }
-  
+
   return sum;
 };
@@ -34,10 +34,10 @@
  * Initialises molecule list with correctly referenced start and end, and sets molecule::last_atom to zero.
  */
-molecule::molecule(periodentafel *teil) 
-{ 
+molecule::molecule(periodentafel *teil)
+{
   // init atom chain list
-  start = new atom; 
+  start = new atom;
   end = new atom;
-  start->father = NULL; 
+  start->father = NULL;
   end->father = NULL;
   link(start,end);
@@ -46,7 +46,7 @@
   last = new bond(start, end, 1, -1);
   link(first,last);
-  // other stuff 
+  // other stuff
   MDSteps = 0;
-  last_atom = 0; 
+  last_atom = 0;
   elemente = teil;
   AtomCount = 0;
@@ -67,5 +67,5 @@
  * Initialises molecule list with correctly referenced start and end, and sets molecule::last_atom to zero.
  */
-molecule::~molecule() 
+molecule::~molecule()
 {
   if (ListOfBondsPerAtom != NULL)
@@ -78,16 +78,16 @@
   delete(last);
   delete(end);
-  delete(start); 
+  delete(start);
 };
 
 /** Adds given atom \a *pointer from molecule list.
- * Increases molecule::last_atom and gives last number to added atom and names it according to its element::abbrev and molecule::AtomCount 
+ * Increases molecule::last_atom and gives last number to added atom and names it according to its element::abbrev and molecule::AtomCount
  * \param *pointer allocated and set atom
  * \return true - succeeded, false - atom not found in list
  */
 bool molecule::AddAtom(atom *pointer)
-{ 
+{
   if (pointer != NULL) {
-    pointer->sort = &pointer->nr; 
+    pointer->sort = &pointer->nr;
     pointer->nr = last_atom++;  // increase number within molecule
     AtomCount++;
@@ -106,5 +106,5 @@
     return add(pointer, end);
   } else
-    return false; 
+    return false;
 };
 
@@ -115,5 +115,5 @@
  */
 atom * molecule::AddCopyAtom(atom *pointer)
-{ 
+{
   if (pointer != NULL) {
   	atom *walker = new atom();
@@ -122,5 +122,5 @@
     walker->v.CopyVector(&pointer->v); // copy velocity
     walker->FixedIon = pointer->FixedIon;
-    walker->sort = &walker->nr; 
+    walker->sort = &walker->nr;
     walker->nr = last_atom++;  // increase number within molecule
     walker->father = pointer; //->GetTrueFather();
@@ -133,5 +133,5 @@
     return walker;
   } else
-    return NULL; 
+    return NULL;
 };
 
@@ -156,12 +156,12 @@
  *    The lengths for these are \f$f\f$ and \f$g\f$ (from triangle H1-H2-(center of H1-H2-H3)) with knowledge that
  *    the median lines in an isosceles triangle meet in the center point with a ratio 2:1.
- *    \f[ f = \frac{b}{\sqrt{3}} \qquad g = \frac{b}{2} 
+ *    \f[ f = \frac{b}{\sqrt{3}} \qquad g = \frac{b}{2}
  *    \f]
- *    as the coordination of all three atoms in the coordinate system of these three vectors: 
+ *    as the coordination of all three atoms in the coordinate system of these three vectors:
  *    \f$\pmatrix{d & f & 0}\f$, \f$\pmatrix{d & -0.5 \cdot f & g}\f$ and \f$\pmatrix{d & -0.5 \cdot f & -g}\f$.
- * 
+ *
  * \param *out output stream for debugging
- * \param *Bond pointer to bond between \a *origin and \a *replacement 
- * \param *TopOrigin son of \a *origin of upper level molecule (the atom added to this molecule as a copy of \a *origin) 
+ * \param *Bond pointer to bond between \a *origin and \a *replacement
+ * \param *TopOrigin son of \a *origin of upper level molecule (the atom added to this molecule as a copy of \a *origin)
  * \param *origin pointer to atom which acts as the origin for scaling the added hydrogen to correct bond length
  * \param *replacement pointer to the atom which shall be copied as a hydrogen atom in this molecule
@@ -191,9 +191,9 @@
   InBondvector.SubtractVector(&TopOrigin->x);
   bondlength = InBondvector.Norm();
-   
+
    // is greater than typical bond distance? Then we have to correct periodically
    // the problem is not the H being out of the box, but InBondvector have the wrong direction
-   // due to TopReplacement or Origin being on the wrong side! 
-  if (bondlength > BondDistance) { 
+   // due to TopReplacement or Origin being on the wrong side!
+  if (bondlength > BondDistance) {
 //    *out << Verbose(4) << "InBondvector is: ";
 //    InBondvector.Output(out);
@@ -215,5 +215,5 @@
 //    *out << endl;
   } // periodic correction finished
-  
+
   InBondvector.Normalize();
   // get typical bond length and store as scale factor for later
@@ -222,5 +222,5 @@
     cerr << Verbose(3) << "ERROR: There is no typical hydrogen bond distance in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
     return false;
-    BondRescale = bondlength; 
+    BondRescale = bondlength;
   } else {
     if (!IsAngstroem)
@@ -273,5 +273,5 @@
       if (FirstOtherAtom != NULL) { // then we just have this double bond and the plane does not matter at all
 //        *out << Verbose(3) << "Regarding the double bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") to be constructed: Taking " << FirstOtherAtom->Name << " and " << SecondOtherAtom->Name << " along with " << TopOrigin->Name << " to determine orthogonal plane." << endl;
-        
+
         // determine the plane of these two with the *origin
         AllWentWell = AllWentWell && Orthovector1.MakeNormalVector(&TopOrigin->x, &FirstOtherAtom->x, &SecondOtherAtom->x);
@@ -286,5 +286,5 @@
       Orthovector1.Normalize();
       //*out << Verbose(3) << "ReScaleCheck: " << Orthovector1.Norm() << " and " << InBondvector.Norm() << "." << endl;
-      
+
       // create the two Hydrogens ...
       FirstOtherAtom = new atom();
@@ -318,9 +318,9 @@
         SecondOtherAtom->x.x[i] = InBondvector.x[i] * cos(bondangle) + Orthovector1.x[i] * (-sin(bondangle));
       }
-      FirstOtherAtom->x.Scale(&BondRescale);  // rescale by correct BondDistance 
+      FirstOtherAtom->x.Scale(&BondRescale);  // rescale by correct BondDistance
       SecondOtherAtom->x.Scale(&BondRescale);
       //*out << Verbose(3) << "ReScaleCheck: " << FirstOtherAtom->x.Norm() << " and " << SecondOtherAtom->x.Norm() << "." << endl;
       for(int i=NDIM;i--;) { // and make relative to origin atom
-        FirstOtherAtom->x.x[i] += TopOrigin->x.x[i]; 
+        FirstOtherAtom->x.x[i] += TopOrigin->x.x[i];
         SecondOtherAtom->x.x[i] += TopOrigin->x.x[i];
       }
@@ -365,8 +365,8 @@
 //      *out << endl;
       AllWentWell = AllWentWell && Orthovector2.MakeNormalVector(&InBondvector, &Orthovector1);
-//      *out << Verbose(3) << "Orthovector2: "; 
+//      *out << Verbose(3) << "Orthovector2: ";
 //      Orthovector2.Output(out);
 //      *out << endl;
-      
+
       // create correct coordination for the three atoms
       alpha = (TopOrigin->type->HBondAngle[2])/180.*M_PI/2.;  // retrieve triple bond angle from database
@@ -380,10 +380,10 @@
       factors[0] = d;
       factors[1] = f;
-      factors[2] = 0.; 
+      factors[2] = 0.;
       FirstOtherAtom->x.LinearCombinationOfVectors(&InBondvector, &Orthovector1, &Orthovector2, factors);
       factors[1] = -0.5*f;
-      factors[2] = g; 
+      factors[2] = g;
       SecondOtherAtom->x.LinearCombinationOfVectors(&InBondvector, &Orthovector1, &Orthovector2, factors);
-      factors[2] = -g; 
+      factors[2] = -g;
       ThirdOtherAtom->x.LinearCombinationOfVectors(&InBondvector, &Orthovector1, &Orthovector2, factors);
 
@@ -437,5 +437,5 @@
  */
 bool molecule::AddXYZFile(string filename)
-{ 
+{
   istringstream *input = NULL;
   int NumberOfAtoms = 0; // atom number in xyz read
@@ -446,5 +446,5 @@
   string line;    // currently parsed line
   double x[3];    // atom coordinates
-  
+
   xyzfile.open(filename.c_str());
   if (!xyzfile)
@@ -454,8 +454,8 @@
   input = new istringstream(line);
   *input >> NumberOfAtoms;
-  cout << Verbose(0) << "Parsing " << NumberOfAtoms << " atoms in file." << endl; 
+  cout << Verbose(0) << "Parsing " << NumberOfAtoms << " atoms in file." << endl;
   getline(xyzfile,line,'\n'); // Read comment
   cout << Verbose(1) << "Comment: " << line << endl;
-  
+
   if (MDSteps == 0) // no atoms yet present
     MDSteps++;
@@ -491,5 +491,5 @@
   xyzfile.close();
   delete(input);
-  return true; 
+  return true;
 };
 
@@ -503,5 +503,5 @@
   atom *LeftAtom = NULL, *RightAtom = NULL;
   atom *Walker = NULL;
-  
+
   // copy all atoms
   Walker = start;
@@ -510,5 +510,5 @@
     CurrentAtom = copy->AddCopyAtom(Walker);
   }
-  
+
   // copy all bonds
   bond *Binder = first;
@@ -534,5 +534,5 @@
       copy->NoCyclicBonds++;
     NewBond->Type = Binder->Type;
-  }  
+  }
   // correct fathers
   Walker = copy->start;
@@ -551,5 +551,5 @@
     copy->CreateListOfBondsPerAtom((ofstream *)&cout);
   }
-  
+
   return copy;
 };
@@ -576,5 +576,5 @@
 
 /** Remove bond from bond chain list.
- * \todo Function not implemented yet 
+ * \todo Function not implemented yet
  * \param *pointer bond pointer
  * \return true - bound found and removed, false - bond not found/removed
@@ -588,5 +588,5 @@
 
 /** Remove every bond from bond chain list that atom \a *BondPartner is a constituent of.
- * \todo Function not implemented yet 
+ * \todo Function not implemented yet
  * \param *BondPartner atom to be removed
  * \return true - bounds found and removed, false - bonds not found/removed
@@ -621,5 +621,5 @@
   Vector *min = new Vector;
   Vector *max = new Vector;
-  
+
   // gather min and max for each axis
   ptr = start->next;  // start at first in list
@@ -667,5 +667,5 @@
 {
   Vector *min = new Vector;
-  
+
 //  *out << Verbose(3) << "Begin of CenterEdge." << endl;
   atom *ptr = start->next;  // start at first in list
@@ -683,5 +683,5 @@
       }
     }
-//    *out << Verbose(4) << "Maximum is "; 
+//    *out << Verbose(4) << "Maximum is ";
 //    max->Output(out);
 //    *out << ", Minimum is ";
@@ -691,8 +691,8 @@
     max->AddVector(min);
     Translate(min);
-  } 
+  }
   delete(min);
 //  *out << Verbose(3) << "End of CenterEdge." << endl;
-}; 
+};
 
 /** Centers the center of the atoms at (0,0,0).
@@ -704,18 +704,18 @@
   int Num = 0;
   atom *ptr = start->next;  // start at first in list
- 
+
   for(int i=NDIM;i--;) // zero center vector
     center->x[i] = 0.;
-    
+
   if (ptr != end) {   //list not empty?
     while (ptr->next != end) {  // continue with second if present
       ptr = ptr->next;
       Num++;
-      center->AddVector(&ptr->x);       
+      center->AddVector(&ptr->x);
     }
     center->Scale(-1./Num); // divide through total number (and sign for direction)
     Translate(center);
   }
-}; 
+};
 
 /** Returns vector pointing to center of gravity.
@@ -729,5 +729,5 @@
   Vector tmp;
   double Num = 0;
-  
+
   a->Zero();
 
@@ -737,5 +737,5 @@
       Num += 1.;
       tmp.CopyVector(&ptr->x);
-      a->AddVector(&tmp);       
+      a->AddVector(&tmp);
     }
     a->Scale(-1./Num); // divide through total mass (and sign for direction)
@@ -757,5 +757,5 @@
 	Vector tmp;
   double Num = 0;
-	
+
 	a->Zero();
 
@@ -766,5 +766,5 @@
       tmp.CopyVector(&ptr->x);
       tmp.Scale(ptr->type->mass);  // scale by mass
-      a->AddVector(&tmp);       
+      a->AddVector(&tmp);
     }
     a->Scale(-1./Num); // divide through total mass (and sign for direction)
@@ -789,5 +789,5 @@
     Translate(center);
   }
-}; 
+};
 
 /** Scales all atoms by \a *factor.
@@ -803,8 +803,8 @@
       Trajectories[ptr].R.at(j).Scale(factor);
     ptr->x.Scale(factor);
-  }      
-};
-
-/** Translate all atoms by given vector. 
+  }
+};
+
+/** Translate all atoms by given vector.
  * \param trans[] translation vector.
  */
@@ -818,8 +818,8 @@
       Trajectories[ptr].R.at(j).Translate(trans);
     ptr->x.Translate(trans);
-  }      
-};
-
-/** Mirrors all atoms against a given plane. 
+  }
+};
+
+/** Mirrors all atoms against a given plane.
  * \param n[] normal vector of mirror plane.
  */
@@ -833,5 +833,5 @@
       Trajectories[ptr].R.at(j).Mirror(n);
     ptr->x.Mirror(n);
-  }      
+  }
 };
 
@@ -847,5 +847,5 @@
   bool flag;
   Vector Testvector, Translationvector;
-  
+
   do {
     Center.Zero();
@@ -863,5 +863,5 @@
           if (Walker->nr < Binder->GetOtherAtom(Walker)->nr) // otherwise we shift one to, the other fro and gain nothing
             for (int j=0;j<NDIM;j++) {
-              tmp = Walker->x.x[j] - Binder->GetOtherAtom(Walker)->x.x[j]; 
+              tmp = Walker->x.x[j] - Binder->GetOtherAtom(Walker)->x.x[j];
               if ((fabs(tmp)) > BondDistance) {
                 flag = false;
@@ -879,5 +879,5 @@
         cout << Verbose(1) << "vector is: ";
         Testvector.Output((ofstream *)&cout);
-        cout << endl;     
+        cout << endl;
 #ifdef ADDHYDROGEN
         // now also change all hydrogens
@@ -892,5 +892,5 @@
             cout << Verbose(1) << "Hydrogen vector is: ";
             Testvector.Output((ofstream *)&cout);
-            cout << endl;     
+            cout << endl;
           }
         }
@@ -914,9 +914,9 @@
 
 	CenterGravity(out, CenterOfGravity);
-	
-	// reset inertia tensor	
+
+	// reset inertia tensor
 	for(int i=0;i<NDIM*NDIM;i++)
 		InertiaTensor[i] = 0.;
-	
+
 	// sum up inertia tensor
 	while (ptr->next != end) {
@@ -943,5 +943,5 @@
 	}
 	*out << endl;
-	
+
 	// diagonalize to determine principal axis system
 	gsl_eigen_symmv_workspace *T = gsl_eigen_symmv_alloc(NDIM);
@@ -952,13 +952,13 @@
 	gsl_eigen_symmv_free(T);
 	gsl_eigen_symmv_sort(eval, evec, GSL_EIGEN_SORT_ABS_DESC);
-	
+
 	for(int i=0;i<NDIM;i++) {
 		*out << Verbose(1) << "eigenvalue = " << gsl_vector_get(eval, i);
 		*out << ", eigenvector = (" << evec->data[i * evec->tda + 0] << "," << evec->data[i * evec->tda + 1] << "," << evec->data[i * evec->tda + 2] << ")" << endl;
 	}
-	
+
 	// check whether we rotate or not
 	if (DoRotate) {
-	  *out << Verbose(1) << "Transforming molecule into PAS ... "; 
+	  *out << Verbose(1) << "Transforming molecule into PAS ... ";
 	  // the eigenvectors specify the transformation matrix
 	  ptr = start;
@@ -972,8 +972,8 @@
 
 	  // summing anew for debugging (resulting matrix has to be diagonal!)
-	  // reset inertia tensor 
+	  // reset inertia tensor
     for(int i=0;i<NDIM*NDIM;i++)
       InertiaTensor[i] = 0.;
-    
+
     // sum up inertia tensor
     ptr = start;
@@ -1002,5 +1002,5 @@
     *out << endl;
 	}
-	
+
 	// free everything
 	delete(CenterOfGravity);
@@ -1031,5 +1031,5 @@
 
   CountElements();  // make sure ElementsInMolecule is up to date
-  
+
   // check file
   if (input == NULL) {
@@ -1087,5 +1087,5 @@
               Trajectories[walker].U.at(MDSteps).x[d] += 0.5*delta_t*(Trajectories[walker].F.at(MDSteps-1).x[d]+Trajectories[walker].F.at(MDSteps).x[d])/IonMass;
             }
-//            cout << "Integrated position&velocity of step " << (MDSteps) << ": ("; 
+//            cout << "Integrated position&velocity of step " << (MDSteps) << ": (";
 //            for (int d=0;d<NDIM;d++)
 //              cout << Trajectories[walker].R.at(MDSteps).x[d] << " ";          // next step
@@ -1121,10 +1121,10 @@
   MDSteps++;
 
-  
+
   // exit
   return true;
 };
 
-/** Align all atoms in such a manner that given vector \a *n is along z axis. 
+/** Align all atoms in such a manner that given vector \a *n is along z axis.
  * \param n[] alignment vector.
  */
@@ -1145,12 +1145,12 @@
     ptr = ptr->next;
     tmp = ptr->x.x[0];
-    ptr->x.x[0] =  cos(alpha) * tmp + sin(alpha) * ptr->x.x[2]; 
+    ptr->x.x[0] =  cos(alpha) * tmp + sin(alpha) * ptr->x.x[2];
     ptr->x.x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x.x[2];
     for (int j=0;j<MDSteps;j++) {
       tmp = Trajectories[ptr].R.at(j).x[0];
-      Trajectories[ptr].R.at(j).x[0] =  cos(alpha) * tmp + sin(alpha) * Trajectories[ptr].R.at(j).x[2]; 
+      Trajectories[ptr].R.at(j).x[0] =  cos(alpha) * tmp + sin(alpha) * Trajectories[ptr].R.at(j).x[2];
       Trajectories[ptr].R.at(j).x[2] = -sin(alpha) * tmp + cos(alpha) * Trajectories[ptr].R.at(j).x[2];
     }
-  }      
+  }
   // rotate n vector
   tmp = n->x[0];
@@ -1160,5 +1160,5 @@
   n->Output((ofstream *)&cout);
   cout << endl;
-  
+
   // rotate on z-y plane
   ptr = start;
@@ -1168,17 +1168,17 @@
     ptr = ptr->next;
     tmp = ptr->x.x[1];
-    ptr->x.x[1] =  cos(alpha) * tmp + sin(alpha) * ptr->x.x[2]; 
+    ptr->x.x[1] =  cos(alpha) * tmp + sin(alpha) * ptr->x.x[2];
     ptr->x.x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x.x[2];
     for (int j=0;j<MDSteps;j++) {
       tmp = Trajectories[ptr].R.at(j).x[1];
-      Trajectories[ptr].R.at(j).x[1] =  cos(alpha) * tmp + sin(alpha) * Trajectories[ptr].R.at(j).x[2]; 
+      Trajectories[ptr].R.at(j).x[1] =  cos(alpha) * tmp + sin(alpha) * Trajectories[ptr].R.at(j).x[2];
       Trajectories[ptr].R.at(j).x[2] = -sin(alpha) * tmp + cos(alpha) * Trajectories[ptr].R.at(j).x[2];
     }
-  }      
+  }
   // rotate n vector (for consistency check)
   tmp = n->x[1];
   n->x[1] =  cos(alpha) * tmp +  sin(alpha) * n->x[2];
   n->x[2] = -sin(alpha) * tmp +  cos(alpha) * n->x[2];
-  
+
   cout << Verbose(1) << "alignment vector after second rotation: ";
   n->Output((ofstream *)&cout);
@@ -1191,10 +1191,10 @@
  * \return true - succeeded, false - atom not found in list
  */
-bool molecule::RemoveAtom(atom *pointer)  
-{ 
+bool molecule::RemoveAtom(atom *pointer)
+{
   if (ElementsInMolecule[pointer->type->Z] != 0)  // this would indicate an error
     ElementsInMolecule[pointer->type->Z]--;  // decrease number of atom of this element
   else
-    cerr << "ERROR: Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl; 
+    cerr << "ERROR: Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl;
   if (ElementsInMolecule[pointer->type->Z] == 0)  // was last atom of this element?
     ElementCount--;
@@ -1206,7 +1206,7 @@
  * \return true - succeeded, false - atom not found in list
  */
-bool molecule::CleanupMolecule() 
-{ 
-  return (cleanup(start,end) && cleanup(first,last)); 
+bool molecule::CleanupMolecule()
+{
+  return (cleanup(start,end) && cleanup(first,last));
 };
 
@@ -1222,5 +1222,5 @@
   } else {
     cout << Verbose(0) << "Atom not found in list." << endl;
-    return NULL;  
+    return NULL;
   }
 };
@@ -1271,5 +1271,5 @@
   struct lsq_params *par = (struct lsq_params *)params;
   atom *ptr = par->mol->start;
-  
+
   // initialize vectors
   a.x[0] = gsl_vector_get(x,0);
@@ -1301,5 +1301,5 @@
 {
     int np = 6;
-    
+
    const gsl_multimin_fminimizer_type *T =
      gsl_multimin_fminimizer_nmsimplex;
@@ -1307,19 +1307,19 @@
    gsl_vector *ss;
    gsl_multimin_function minex_func;
- 
+
    size_t iter = 0, i;
    int status;
    double size;
- 
+
    /* Initial vertex size vector */
    ss = gsl_vector_alloc (np);
- 
+
    /* Set all step sizes to 1 */
    gsl_vector_set_all (ss, 1.0);
- 
+
    /* Starting point */
    par->x = gsl_vector_alloc (np);
    par->mol = this;
- 
+
    gsl_vector_set (par->x, 0, 0.0);  // offset
    gsl_vector_set (par->x, 1, 0.0);
@@ -1328,29 +1328,29 @@
    gsl_vector_set (par->x, 4, 0.0);
    gsl_vector_set (par->x, 5, 1.0);
- 
+
    /* Initialize method and iterate */
    minex_func.f = &LeastSquareDistance;
    minex_func.n = np;
    minex_func.params = (void *)par;
- 
+
    s = gsl_multimin_fminimizer_alloc (T, np);
    gsl_multimin_fminimizer_set (s, &minex_func, par->x, ss);
- 
+
    do
      {
        iter++;
        status = gsl_multimin_fminimizer_iterate(s);
- 
+
        if (status)
          break;
- 
+
        size = gsl_multimin_fminimizer_size (s);
        status = gsl_multimin_test_size (size, 1e-2);
- 
+
        if (status == GSL_SUCCESS)
          {
            printf ("converged to minimum at\n");
          }
- 
+
        printf ("%5d ", (int)iter);
        for (i = 0; i < (size_t)np; i++)
@@ -1361,5 +1361,5 @@
      }
    while (status == GSL_CONTINUE && iter < 100);
- 
+
   for (i=0;i<(size_t)np;i++)
     gsl_vector_set(par->x, i, gsl_vector_get(s->x, i));
@@ -1378,5 +1378,5 @@
   int ElementNo, AtomNo;
   CountElements();
-  
+
   if (out == NULL) {
     return false;
@@ -1413,5 +1413,5 @@
   int ElementNo, AtomNo;
   CountElements();
-  
+
   if (out == NULL) {
     return false;
@@ -1460,5 +1460,5 @@
   atom *Walker = start;
   while (Walker->next != end) {
-    Walker = Walker->next; 
+    Walker = Walker->next;
 #ifdef ADDHYDROGEN
     if (Walker->type->Z != 1) {   // regard only non-hydrogen
@@ -1491,5 +1491,5 @@
   int No = 0;
   time_t now;
-  
+
   now = time((time_t *)NULL);   // Get the system time and put it into 'now' as 'calender time'
   walker = start;
@@ -1520,5 +1520,5 @@
   int No = 0;
   time_t now;
-  
+
   now = time((time_t *)NULL);   // Get the system time and put it into 'now' as 'calender time'
   walker = start;
@@ -1563,5 +1563,5 @@
 	      Walker->nr = i;   // update number in molecule (for easier referencing in FragmentMolecule lateron)
 	      if (Walker->type->Z != 1) // count non-hydrogen atoms whilst at it
-	        NoNonHydrogen++; 
+	        NoNonHydrogen++;
 	      Free((void **)&Walker->Name, "molecule::CountAtoms: *walker->Name");
 	      Walker->Name = (char *) Malloc(sizeof(char)*6, "molecule::CountAtoms: *walker->Name");
@@ -1571,5 +1571,5 @@
 	    }
     } else
-    	*out << Verbose(3) << "AtomCount is still " << AtomCount << ", thus counting nothing." << endl; 
+    	*out << Verbose(3) << "AtomCount is still " << AtomCount << ", thus counting nothing." << endl;
   }
 };
@@ -1583,5 +1583,5 @@
   	ElementsInMolecule[i] = 0;
 	ElementCount = 0;
-	
+
   atom *walker = start;
   while (walker->next != end) {
@@ -1619,5 +1619,5 @@
     Binder = Binder->next;
     if (Binder->Cyclic)
-      No++;    
+      No++;
   }
   delete(BackEdgeStack);
@@ -1679,5 +1679,5 @@
  * Generally, we use the CSD approach to bond recognition, that is the the distance
  * between two atoms A and B must be within [Rcov(A)+Rcov(B)-t,Rcov(A)+Rcov(B)+t] with
- * a threshold t = 0.4 Angstroem. 
+ * a threshold t = 0.4 Angstroem.
  * To make it O(N log N) the function uses the linked-cell technique as follows:
  * The procedure is step-wise:
@@ -1694,6 +1694,50 @@
  * \param IsAngstroem whether coordinate system is gauged to Angstroem or Bohr radii
  */
+void molecule::CreateAdjacencyList2(ofstream *out, ifstream *input)// ofstream* out, double bonddistance, bool IsAngstroem)
+{
+
+	// 1 We will parse bonds out of the dbond file created by tremolo.
+			int atom1, atom2, temp;
+			atom *Walker, *OtherWalker;
+
+	        if (!input)
+	        {
+	        	cout << Verbose(1) << "Opening silica failed \n";
+	        };
+
+			*input >> ws >> atom1;
+			*input >> ws >> atom2;
+	        cout << Verbose(1) << "Scanning file\n";
+	        while (!input->eof()) // Check whether we read 2 items
+	        {
+				*input >> ws >> atom1;
+				*input >> ws >> atom2;
+	        	if(atom2<atom1) //Sort indizes of atoms in order
+	        	{
+	        		temp=atom1;
+	        		atom1=atom2;
+	        		atom2=temp;
+	        	};
+
+	        	Walker=start;
+	        	while(Walker-> nr != atom1) // Find atom corresponding to first index
+	        	{
+	        		Walker = Walker->next;
+	        	};
+	        	OtherWalker = Walker->next;
+	        	while(OtherWalker->nr != atom2) // Find atom corresponding to second index
+	        	{
+	        		OtherWalker= OtherWalker->next;
+	        	};
+	        	AddBond(Walker, OtherWalker); //Add the bond between the two atoms with respective indices.
+	        	BondCount++; //Increase bond count of molecule
+	        }
+
+	        CreateListOfBondsPerAtom(out);
+
+};
 void molecule::CreateAdjacencyList(ofstream *out, double bonddistance, bool IsAngstroem)
 {
+
   atom *Walker = NULL, *OtherWalker = NULL, *Candidate = NULL;
   int No, NoBonds, CandidateBondNo;
@@ -1704,5 +1748,5 @@
   Vector x;
   int FalseBondDegree = 0;
- 
+
   BondDistance = bonddistance; // * ((IsAngstroem) ? 1. : 1./AtomicLengthToAngstroem);
   *out << Verbose(0) << "Begin of CreateAdjacencyList." << endl;
@@ -1711,5 +1755,5 @@
     cleanup(first,last);
   }
-	
+
   // count atoms in molecule = dimension of matrix (also give each unique name and continuous numbering)
   CountAtoms(out);
@@ -1730,5 +1774,5 @@
     for (int i=NumberCells;i--;)
       CellList[i] = NULL;
-  
+
     // 2b. put all atoms into its corresponding list
     Walker = start;
@@ -1751,10 +1795,11 @@
       if (CellList[index] == NULL)  // allocate molecule if not done
         CellList[index] = new molecule(elemente);
-      OtherWalker = CellList[index]->AddCopyAtom(Walker); // add a copy of walker to this atom, father will be walker for later reference 
-      //*out << Verbose(1) << "Copy Atom is " << *OtherWalker << "." << endl; 
+      OtherWalker = CellList[index]->AddCopyAtom(Walker); // add a copy of walker to this atom, father will be walker for later reference
+      //*out << Verbose(1) << "Copy Atom is " << *OtherWalker << "." << endl;
     }
     //for (int i=0;i<NumberCells;i++)
       //*out << Verbose(1) << "Cell number " << i << ": " << CellList[i] << "." << endl;
-      
+
+
     // 3a. go through every cell
     for (N[0]=divisor[0];N[0]--;)
@@ -1769,5 +1814,5 @@
               Walker = Walker->next;
               //*out << Verbose(0) << "Current Atom is " << *Walker << "." << endl;
-              // 3c. check for possible bond between each atom in this and every one in the 27 cells 
+              // 3c. check for possible bond between each atom in this and every one in the 27 cells
               for (n[0]=-1;n[0]<=1;n[0]++)
                 for (n[1]=-1;n[1]<=1;n[1]++)
@@ -1801,4 +1846,7 @@
           }
         }
+
+
+
     // 4. free the cell again
     for (int i=NumberCells;i--;)
@@ -1807,8 +1855,8 @@
       }
     Free((void **)&CellList, "molecule::CreateAdjacencyList - ** CellList");
-    
+
     // create the adjacency list per atom
     CreateListOfBondsPerAtom(out);
-  		
+
     // correct Bond degree of each bond by checking both bond partners for a mismatch between valence and current sum of bond degrees,
     // iteratively increase the one first where the other bond partner has the fewest number of bonds (i.e. in general bonds oxygene
@@ -1859,5 +1907,5 @@
 			*out << Verbose(1) << "BondCount is " << BondCount << ", no bonds between any of the " << AtomCount << " atoms." << endl;
 	  *out << Verbose(1) << "I detected " << BondCount << " bonds in the molecule with distance " << bonddistance << ", " << FalseBondDegree << " bonds could not be corrected." << endl;
-		
+
 	  // output bonds for debugging (if bond chain list was correctly installed)
 	  *out << Verbose(1) << endl << "From contents of bond chain list:";
@@ -1869,8 +1917,11 @@
     *out << endl;
   } else
-  	*out << Verbose(1) << "AtomCount is " << AtomCount << ", thus no bonds, no connections!." << endl; 
+  	*out << Verbose(1) << "AtomCount is " << AtomCount << ", thus no bonds, no connections!." << endl;
   *out << Verbose(0) << "End of CreateAdjacencyList." << endl;
   Free((void **)&matrix, "molecule::CreateAdjacencyList: *matrix");
-};
+
+};
+
+
 
 /** Performs a Depth-First search on this molecule.
@@ -1893,7 +1944,7 @@
   bond *Binder = NULL;
   bool BackStepping = false;
-  
+
   *out << Verbose(0) << "Begin of DepthFirstSearchAnalysis" << endl;
-  
+
   ResetAllBondsToUnused();
   ResetAllAtomNumbers();
@@ -1908,5 +1959,5 @@
     LeafWalker->Leaf = new molecule(elemente);
     LeafWalker->Leaf->AddCopyAtom(Root);
-    
+
     OldGraphNr = CurrentGraphNr;
     Walker = Root;
@@ -1919,5 +1970,5 @@
           AtomStack->Push(Walker);
           CurrentGraphNr++;
-        }      
+        }
         do { // (3) if Walker has no unused egdes, go to (5)
           BackStepping = false; // reset backstepping flag for (8)
@@ -1953,10 +2004,10 @@
           Binder = NULL;
       } while (1);  // (2)
-      
+
       // if we came from backstepping, yet there were no more unused bonds, we end up here with no Ancestor, because Walker is Root! Then we are finished!
       if ((Walker == Root) && (Binder == NULL))
         break;
-        
-      // (5) if Ancestor of Walker is ... 
+
+      // (5) if Ancestor of Walker is ...
       *out << Verbose(1) << "(5) Number of Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "] is " << Walker->Ancestor->GraphNr << "." << endl;
       if (Walker->Ancestor->GraphNr != Root->GraphNr) {
@@ -2001,5 +2052,5 @@
         } while (OtherAtom != Walker);
         ComponentNumber++;
-    
+
         // (11) Root is separation vertex,  set Walker to Root and go to (4)
         Walker = Root;
@@ -2014,5 +2065,5 @@
 
     // From OldGraphNr to CurrentGraphNr ranges an disconnected subgraph
-    *out << Verbose(0) << "Disconnected subgraph ranges from " << OldGraphNr << " to " << CurrentGraphNr << "." << endl;    
+    *out << Verbose(0) << "Disconnected subgraph ranges from " << OldGraphNr << " to " << CurrentGraphNr << "." << endl;
     LeafWalker->Leaf->Output(out);
     *out << endl;
@@ -2022,5 +2073,5 @@
       //*out << Verbose(1) << "Current next subgraph root candidate is " << Root->Name << "." << endl;
       if (Root->GraphNr != -1) // if already discovered, step on
-        Root = Root->next; 
+        Root = Root->next;
     }
   }
@@ -2044,5 +2095,5 @@
     *out << " with Lowpoint " << Walker->LowpointNr << " and Graph Nr. " << Walker->GraphNr << "." << endl;
   }
-  
+
   *out << Verbose(1) << "Final graph info for each bond is:" << endl;
   Binder = first;
@@ -2055,5 +2106,5 @@
     *out << ((Binder->rightatom->SeparationVertex) ? "SP," : "") << "L" << Binder->rightatom->LowpointNr << " G" << Binder->rightatom->GraphNr << " Comp.";
     OutputComponentNumber(out, Binder->rightatom);
-    *out << ">." << endl; 
+    *out << ">." << endl;
     if (Binder->Cyclic) // cyclic ??
       *out << Verbose(3) << "Lowpoint at each side are equal: CYCLIC!" << endl;
@@ -2070,5 +2121,5 @@
  * the other our initial Walker - and do a Breadth First Search for the Root. We mark down each Predecessor and as soon as
  * we have found the Root via BFS, we may climb back the closed cycle via the Predecessors. Thereby we mark atoms and bonds
- * as cyclic and print out the cycles. 
+ * as cyclic and print out the cycles.
  * \param *out output stream for debugging
  * \param *BackEdgeStack stack with all back edges found during DFS scan. Beware: This stack contains the bonds from the total molecule, not from the subgraph!
@@ -2081,5 +2132,5 @@
   int *ShortestPathList = (int *) Malloc(sizeof(int)*AtomCount, "molecule::CyclicStructureAnalysis: *ShortestPathList");
   enum Shading *ColorList = (enum Shading *) Malloc(sizeof(enum Shading)*AtomCount, "molecule::CyclicStructureAnalysis: *ColorList");
-  class StackClass<atom *> *BFSStack = new StackClass<atom *> (AtomCount);   // will hold the current ring 
+  class StackClass<atom *> *BFSStack = new StackClass<atom *> (AtomCount);   // will hold the current ring
   class StackClass<atom *> *TouchedStack = new StackClass<atom *> (AtomCount);   // contains all "touched" atoms (that need to be reset after BFS loop)
   atom *Walker = NULL, *OtherAtom = NULL, *Root = NULL;
@@ -2093,8 +2144,8 @@
     ColorList[i] = white;
   }
-  
+
   *out << Verbose(1) << "Back edge list - ";
   BackEdgeStack->Output(out);
-  
+
   *out << Verbose(1) << "Analysing cycles ... " << endl;
   NumCycles = 0;
